//drawObj.cpp

/*
The physical simulation is located here
*************************
***Group 13 2005***
*************************
*/


#include "unicycle.h"


      float force=0.0f;								// Force Applied On This Mass At An Instance.
      static float pos=0.0f;					   // Position In Space.	
      float vel=0.0f;							   // Velocity.
      float acc=0.0f;                              //acceleration
      float theta=0.0f;                            //the angle of the rod
      static float thetaVel=0.0f;                  //the angulas speed of the rod
      static float thetaAcc=0.0f;                  //angular acceleration of the rod

      float L1,L2,L3,L4;                           //control vector from acker, MATLAB

 object::object(void)							   // Constructor.
	{
     //the result from acker when placing poles in -2 -2 -1+i, -1
            L1=    -0.0188     *1000  ;
            L2=   -0.0162  *1000 ;
            L3=  -1.1267   *1000;
            L4=  -0.1033*1000  ;             
              
	}

	object::~object(void)							//	 Destructor
	{
		
	}
	
	void object::resetAll() //Nollstller alla tillstnd
	{
	  force=0.0f;							  // Force Applied On This Mass At An Instance.
      pos=0.0f;								  // Position In Space.	
      vel=0.0f;								  // Velocity.
      acc=0.0f;                               //acceleration
      theta=0.0f;                             //the angle of the rod
      thetaVel=0.0f;                          //the angulas speed of the rod
      thetaAcc=0.0f;                          //angular acceleration of the rod
    }
    
    
    
	float object::move()
	{   float d= 1.0f/M;

	    //calculation of the vehicle acceleration goes here. the first term is th e friction.
        acc =-0.1*vel + (-m*d*g*theta)+ (m*d*f*thetaVel)+ d*calculateForce();
        
        if(abs(theta) < pi/4) //is the angle inside the allowed boundary?
        acc=acc - d*(L1*pos + L2*vel + L3*theta + L4*thetaVel); //if so, control it

        vel += dt*acc;  //Euler of velocity

        return vel;       
	}
	
	float object::bend()
	{   
	
	 float d=1.0f/(M*l); //just to make the code smaller
     float mass=(M+m)*d; //just to make the code smaller

     //calculation of the angular acceleration goes here, as in move()
     thetaAcc= (mass*g*theta)+(-mass*f*thetaVel)  +(-d*calculateForce());
     
        if(abs(theta) < pi/6)thetaAcc=thetaAcc + d*(L1*pos + L2*vel + L3*theta + L4*thetaVel) ;

        thetaVel +=dt*thetaAcc; //Euler
		theta +=dt*thetaVel;
		
		return radToGrad*theta;
}      

//this is a method for an external input signal, not in use this time
float object::calculateForce(){return 0;}
